#define CreeObjet(obj_number,char_number,xpos,ypos,obj_mode,obj_shape,obj_size,color_mode,pal_number,prio_to_bg,vflip,hflip,mosaic,rotation,rotation_no,dblsize) \
                        \
                        MonOAM[obj_number].attribut0= \
                        (obj_shape<<14)  | \
                        (color_mode<<13) | \
                        (mosaic<<12)     | \
                        (obj_mode<<10)   | \
                        (rotation<<8)    | \
                        (dblsize<<9)     | \
                        (ypos); \
                        \
                        MonOAM[obj_number].attribut1= \
                        (obj_size<<14)   |\
                        (vflip<<13)      |\
                        (hflip<<12)      |\
                        (rotation_no<<9) |\
                        (xpos);\
                        \
                        MonOAM[obj_number].attribut2= \
                        (pal_number<<12) |\
                        (prio_to_bg<<10) |\
                        (char_number);


#define PlaceObjetXY(obj_number,xpos,ypos)\
                        MonOAM[obj_number].attribut1 &= 0xFE00;\
                        MonOAM[obj_number].attribut1 |= xpos;\
                        MonOAM[obj_number].attribut0 &= 0xFF00;\
                        MonOAM[obj_number].attribut0 |= ypos;

#define DetruitObjet(obj_number)\
                        MonOAM[obj_number].attribut0 = 240;\
                        MonOAM[obj_number].attribut1 = 160;\
                        MonOAM[obj_number].attribut2 = 0;

#define TOOL_OAM_OBJ_SET_XPOS(obj_number,xpos)\
                        *(volatile u16 *)(MEM_OAM+(8*obj_number)+2) &= 0xFE00;\
                        *(volatile u16 *)(MEM_OAM+(8*obj_number)+2) |= xpos;

#define TOOL_OAM_OBJ_SET_YPOS(obj_number,ypos)\
                        *(volatile u16 *)(MEM_OAM+(8*obj_number)) &= 0xFF00;\
                        *(volatile u16 *)(MEM_OAM+(8*obj_number)) |= ypos;

#define RetourneObjetH_Oui(obj_number)\
                        MonOAM[obj_number].attribut1 |= 0x1000;

#define RetourneObjetH_Non(obj_number)\
                        MonOAM[obj_number].attribut1 &= 0xEFFF;

#define TOOL_OAM_OBJ_SET_VFLIP_ON(obj_number)\
                        *(volatile u16 *)(MEM_OAM+(8*obj_number)+2) |= 0x2000;

#define TOOL_OAM_OBJ_SET_VFLIP_OFF(obj_number)\
                        *(volatile u16 *)(MEM_OAM+(8*obj_number)+2) &= 0xDFFF;

#define TOOL_OAM_OBJ_SET_MOSAIC_ON(obj_number)\
                        *(volatile u16 *)(MEM_OAM+(8*obj_number)) |= 0x1000;

#define TOOL_OAM_OBJ_SET_MOSAIC_OFF(obj_number)\
                        *(volatile u16 *)(MEM_OAM+(8*obj_number)) &= 0xEFFF;

#define ChangeTileObjet(obj_number,char_number)\
                        MonOAM[obj_number].attribut2 &= 0xFC00;\
                        MonOAM[obj_number].attribut2 |= char_number;

#define TOOL_OAM_OBJ_SET_PRIO(obj_number,prio)\
                        *(volatile u16 *)(MEM_OAM+(8*obj_number)+4) &= 0xF3FF;\
                        *(volatile u16 *)(MEM_OAM+(8*obj_number)+4) |= prio<<10;

#define TOOL_OAM_OBJ_SET_PAL(obj_number,pal_number)\
                        *(volatile u16 *)(MEM_OAM+(8*obj_number)+4) &= 0xFFF;\
                        *(volatile u16 *)(MEM_OAM+(8*obj_number)+4) |= pal_number<<12;
#define TOOL_OAM_OBJ_SET_ROT(obj_number,rot)\
                        *(volatile u16 *)(MEM_OAM+(8*obj_number)) &= 0xFEFF;\
                        *(volatile u16 *)(MEM_OAM+(8*obj_number)) |= rot<<8;
#define TOOL_OAM_OBJ_SET_ROTSET(obj_number,rotset)\
                        *(volatile u16 *)(MEM_OAM+(8*obj_number)+2) &= 0xC1FF;\
                        *(volatile u16 *)(MEM_OAM+(8*obj_number)+2) |= rotset<<9;

#undef TOOL_OAM_OBJ_KILL
#define TOOL_OAM_OBJ_KILL(obj_number)\
                        *(volatile u16 *)(MEM_OAM+(8*obj_number)) = 240;\
                        *(volatile u16 *)(MEM_OAM+(8*obj_number)+2) = 160;\
                        *(volatile u16 *)(MEM_OAM+(8*obj_number)+4) = 0;

void PositionRelativeObjet16x16(int posX,int posY, int x,int y, int *resultatX, int *resultatY)      {
    int i,j;
    i=posX-x;
    if (i>240)
        i=240;
    if (i<0 && i>-16)
        i=512+i;
    j=posY-y;
    if (j>160)
        j=160;
    if (j<0 && j>-16)
        j=256+j;
    if (i<0)
        i=240;
    if (j<0)
        j=160;
    *resultatX=i;
    *resultatY=j;
}

